/////////////////////////////////////
//
//  The 1969 Moon Landing Was a Hoax !!!
//

precision highp float;       	// Set the default precision to medium. We don't need as high of a
								// precision in the fragment shader.

uniform sampler2D u_TextureMap;    // The input Map texture.
uniform sampler2D u_TextureBump;   // The input Bump texture.

uniform float u_Brightness;
  
varying vec4 v_Diffuse;
varying vec2 v_Tex;
varying vec2 v_Spec;
varying vec3 v_Light;
varying vec3 v_View;
varying vec3 v_Par;
  
// The entry point for our fragment shader.
void main()                    		
{
    vec3 sunlightColor;
	sunlightColor.r = 250.0/255.0;
	sunlightColor.g = 227.0/255.0;
	sunlightColor.b = 226.0/255.0;

	// for parallax
	float scalePar = 0.005;
	float bPar = scalePar * 0.5;
	vec4 heightPar = scalePar * texture2D(u_TextureBump, v_Tex) - bPar;
	vec2 Nt;
	Nt.y = v_Tex.y - (-v_Par.y)*heightPar.a;
	Nt.x = v_Tex.x + (v_Par.x)*heightPar.a;

	// sample all 4 textures
	vec4 vCol0 = texture2D(u_TextureMap, Nt); // day colormap with specularmap
	vec4 vCol1 = texture2D(u_TextureBump, Nt); // Nt // normalmap

    vec3 vNorm = vCol1.xyz;

	// unpack normals
	vNorm = (vNorm * 2.0) - 1.0;
	vNorm.y = vNorm.y * 1.5;
	vNorm.xyz = normalize(vNorm.xyz);

	// bump
	vec4 n_dot_l = vec4(clamp(1.1 * dot(vNorm,v_Light), 0.0, 1.0));
	vec4 diffuse = max(n_dot_l,0.15);

	// calc colormap between day colormap and night colormap and apply lighting to day colormap
	vec4 finalColor = clamp(vCol0 * diffuse * u_Brightness, 0.0, 1.0);

	finalColor.a = 1.0;

    gl_FragColor = finalColor;
}

