precision highp float;       	// Set the default precision to medium. We don't need as high of a
								// precision in the fragment shader.

uniform sampler2D u_TextureMap;    // The input Map texture.

uniform float u_Brightness;

varying vec2 v_Tex;
varying vec2 v_Ver;
varying vec2 v_Sun;

// The entry point for our fragment shader.
void main()                    		
{
	vec4 texelColor = texture2D(u_TextureMap, v_Tex); // day colormap with specularmap
	texelColor.a = texelColor.a;

	// shadow
	vec2 fVer;
	vec2 fSun;

	// dist
	fSun = v_Sun;
	fVer = v_Ver;

	float fDistance = sqrt(dot(fVer, fVer));

	fVer = normalize(fVer);
	float fCosAngle = dot(fVer, fSun);
	float fSinAngle = sqrt(clamp(1.0 - (fCosAngle * fCosAngle), 0.0, 1.0));

	float fShadowDist = fDistance * fSinAngle;

	fCosAngle = dot(-fVer, fSun);

	float fShadowCol = 1.0;
	if (fCosAngle > 0.0)
	{
		fShadowCol = clamp(clamp(clamp(fShadowDist - 1.0, 0.0, 1.0) * 20.0, 0.0, 1.0) + 0.25, 0.0, 1.0);
	}

	texelColor.rgb = texelColor.rgb * fShadowCol;

	texelColor.rgb = clamp(texelColor.rgb * u_Brightness, 0.0, 1.0);

    gl_FragColor = texelColor;
}

