uniform mat4 u_MVPMatrix;		// A constant representing the combined model/view/projection matrix.
uniform vec4 u_EyePos;
uniform vec4 u_SunConst;
uniform vec4 u_PlanetOffset;

attribute vec3 a_Position;		// Per-vertex position information we will pass in.
attribute vec3 a_Normal;		// Per-vertex normal information we will pass in.
attribute vec2 a_TexCoordinate; // Per-vertex texture coordinate information we will pass in.

varying vec2 v_Tex;
varying vec2 v_Ver;
varying vec2 v_Sun;


void main()
{
    vec4 vPosOut = vec4(a_Position.xyz, 1.0);
	vPosOut.xyz =  vPosOut.xyz + u_PlanetOffset.xyz;

	v_Tex = a_TexCoordinate;

	// shadow
	v_Sun.x = u_SunConst.x;
	v_Sun.y = u_SunConst.y;

	v_Ver.x = a_Position.x;
	v_Ver.y = a_Position.z;

	gl_Position = u_MVPMatrix * vPosOut;
}