precision highp float;       	// Set the default precision to medium. We don't need as high of a
								// precision in the fragment shader.

uniform sampler2D u_TextureMap;    // The input texture.
uniform float u_Brightness;
  
varying vec2 v_TexCoordinate;   // Interpolated texture coordinate per fragment.
  
// The entry point for our fragment shader.
void main()                    		
{
    vec4 texelColor = texture2D(u_TextureMap, v_TexCoordinate);

    gl_FragColor = vec4 (clamp(texelColor.rgb * u_Brightness, 0.0, 1.0), 1.0);
}

